-- Alphabet Soup Game
-- Developed by Carlos Yanez

-- Hide Status Bar

display.setStatusBar(display.HiddenStatusBar)

-- Graphics
-- [Background]

-- [Game Background]

local gameBg = display.newImage('bg.png')

-- [Title View]
 
local titleBg
local title
local startBtn
local aboutBtn

-- [TitleView Group]

local titleView

-- [CreditsView]

local about

-- [Words List Textfield]

local wordsList
local currentWords

-- [Letter Texfields Container]

local tfs = display.newGroup()

-- [Selection Line]

local line
local lines = display.newGroup()

-- [Alert]

local alert

-- [Sound]

local bell = audio.loadStream('bell.caf')

-- Variables

local L1 = {'IPHONE', 'ANDROID', 'CORONA', 'MOBILE', 'GAMES'}
local L1Map = {{0, 0, 'I', 0, 0, 0, 'G', 0, 0, 0},
               {0, 0, 'P', 0, 0, 0, 'A', 0, 0, 0},
               {0, 0, 'H', 0, 0, 0, 'M', 0, 0, 0},
               {0, 'M', 'O', 'B', 'I', 'L', 'E', 0, 0, 0},
               {0, 0, 'N', 0, 0, 0, 'S', 0, 0, 0},
               {0, 0, 'E', 0, 0, 0, 0, 0, 0, 0},
               {'C', 'O', 'R', 'O', 'N', 'A', 0, 0, 0, 0},
               {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
               {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
               {0, 0, 'A', 'N', 'D', 'R', 'O', 'I', 'D', 0},
               {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
               {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}}

local alphabet = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'}
local correct = 0

-- Functions

local Main = {}
local addTitleView = {}
local startBtnuttonListeners = {}
local showCredits = {}
local hideCredits = {}
local showGameView = {}
local gameListeners = {}
local buildSoup = {}
local startDraw = {}
local hitTestObjects = {}
local detectLetters = {}
local alert = {}

function Main()
	addTitleView()
end

function addTitleView()
	titleBg = display.newImage('titleBg.png')
	
	title = display.newImage('title.png')
	title.x = display.contentCenterX
	title.y = 120
	
	startBtn = display.newImage('startBtn.png')
	startBtn.x = display.contentCenterX
	startBtn.y = display.contentCenterY + 20
	
	aboutBtn = display.newImage('aboutBtn.png')
	aboutBtn.x = display.contentCenterX
	aboutBtn.y = display.contentCenterY + 65
	
	titleView = display.newGroup()
	titleView:insert(titleBg)
	titleView:insert(title)
	titleView:insert(startBtn)
	titleView:insert(aboutBtn)
	
	startButtonListeners('add')
end

function startButtonListeners(action)
	if(action == 'add') then	
		aboutBtn:addEventListener('tap', showCredits)
		startBtn:addEventListener('tap', showGameView)
	else	
		aboutBtn:removeEventListener('tap', showCredits)
		startBtn:removeEventListener('tap', showGameView)
	end
end

function showCredits:tap()
	aboutBtn.isVisible = false
	startBtn.isVisible = false
	about = display.newImage('about.png')
	about.x = about.width * 0.474
	about.y = display.contentHeight + about.height

	transition.to(about, {time = 300, y = display.contentHeight - about.height/2.4, onComplete = function() about:addEventListener('tap', hideCredits) end})
end

function hideCredits()
	transition.to(about, {time = 300, y = display.contentHeight+about.height, onComplete = function() aboutBtn.isVisible = true startBtn.isVisible = true about:removeEventListener('tap', hideCredits) display.remove(about) about = nil end})
end

function showGameView:tap()
	transition.to(titleView, {time = 300, y = -titleView.height, onComplete = function() display.remove(titleView) titleView = nil buildSoup() gameListeners('add') end})
end

function gameListeners(action)
	
	if(action == 'add') then
		gameBg:addEventListener('touch', startDraw)
		gameBg:addEventListener('touch', detectLetters)
	else
		gameBg:removeEventListener('touch', startDraw)
		gameBg:removeEventListener('touch', detectLetters)
	end
end

function buildSoup()
	for i = 1, 10 do
		for j = 1, 12 do
			local tf = display.newText('', 0, 0, 'Arial', 19)
			tf:setTextColor(102, 102, 102)
			tf.width = 22
			tf.height = 21
			tf.x = math.floor(-10 + (31.3 * i))
			tf.y = math.floor(-10 + (35 * j))
	
			-- Change 0's to Random Letters 
	
			if(L1Map[j][i] == 0) then
				L1Map[j][i] = alphabet[math.floor(math.random() * table.maxn(alphabet))+1]
			end
	
			tf.text = L1Map[j][i]
			tfs:insert(tf)
		end
	end
	
	-- Add Words List 
	
	local wordsString = ''
	
	for i = 1, #L1 do
		wordsString = wordsString .. ' ' .. L1[i]
	end
	
	wordsList = display.newText(wordsString, 5, 430, 'Arial', 14)
	wordsList:setTextColor(238, 238, 238)
	
	currentWords = display.newText('', 5, 455, 'Arial', 14)
	currentWords:setTextColor(238, 146, 63)
end

function startDraw:touch(e)
	if(e.phase == 'began') then
		initX = e.x
		initY = e.y
	elseif(e.phase == 'ended') then
		line = display.newLine(initX, initY, e.x, e.y)
		line.width = 16
		line:setColor(255, 142, 42, 60)
		lines:insert(line)
	end
end